#include <stdio.h>
#include <stdlib.h>
#include <string.h> 

/*JbR̎*/
#define STAPLE_SMALL  1
#define STAPLE_MEDIUM 2
#define STAPLE_LARGE  3

/* 1̃JbR\ */
typedef struct _tagstaple {
    int line;       /* JbR̂s */
    int column;     /* JbR̂is̕j */
    int type;       /* JbR̎ */

    /* XgɂX^bN\ */
    struct _tagstaple *staple_next;
    struct _tagstaple *staple_prev;
} staple;

/* XgɂX^bN\ */
staple *staple_head = NULL;
staple *staple_last = NULL;

/*X^bNւpush */
void stack_push(int line,int column,int type) {
    staple *staple_new;

    /* V̈m */
    staple_new = (staple*)malloc(sizeof(staple));
    if(staple_new == NULL) {
        printf("X^bNI[ot[łB܂");
        exit(EXIT_FAILURE);
        return;
    }

    /* nꂽlX^bNɐς */
    staple_new->line = line;
    staple_new->column = column;
    staple_new->type = type;

    /* Xg̍Ōɒǉ */
    staple_new->staple_next = NULL;
    staple_new->staple_prev = staple_last;
    staple_last = staple_new;
    if(staple_head == NULL) {
        staple_head = staple_new;
    }
}

/* X^bNpop */
int stack_pop(staple *ret) {
    staple *temp_staple;

    if(staple_head == NULL) {
        /* X^bNɂ͉ȂFJbȒΉƂĂȂ */
        return 0;   /* G[ */
    }

    /* ΂ŌpushꂽJbȐԂ */
    ret->line = staple_last->line;
    ret->column = staple_last->column;
    ret->type = staple_last->type;
    ret->staple_next = ret->staple_prev = NULL;
    temp_staple = staple_last;

    /* Xg폜 */
    if(staple_last->staple_prev == NULL) {
        staple_head = NULL;
    } else {
        staple_last->staple_prev->staple_next = NULL;
    }

    staple_last = staple_last->staple_prev;

    free(temp_staple);

    return 1;   /*  */
}

int main(void) {
    char buffer[4096];
    int i, len, line = 1, carryover = 0;
    staple open;

    for(;;) {
        if(fgets(buffer, 4096, stdin) == NULL) {
        /* I[܂œǂݍ */
            break;
        }
        len = strlen(buffer);
        if(len == 0) {
            continue;
        }

        for(i = 0; i < len; i++) {
            switch(buffer[i]) {
            case '(':
                stack_push(line,carryover + i + 1, STAPLE_SMALL);
                break;
            case '{':
                stack_push(line,carryover + i + 1, STAPLE_MEDIUM);
                break;
            case '[':
                stack_push(line,carryover + i + 1, STAPLE_LARGE);
                break;
            case ')':
                if(stack_pop(&open) == 0) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉ"
                               "JJbR܂\n",
                                        line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                if(open.type!=STAPLE_SMALL) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉJbR"
                            "%ds%dɑΉJbR̎ނ"
                            "Ⴂ܂\n", open.line, open.column,
                                            line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                break;
            case '}':
                if(stack_pop(&open) == 0) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉJJbR"
                            "܂\n", line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                if(open.type!=STAPLE_MEDIUM) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉJbR"
                            "%ds%dɑΉJbR̎ނ"
                            "Ⴂ܂\n", open.line, open.column,
                                            line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                break;
            case ']':
                if(stack_pop(&open)==0) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉJJbR"
                            "܂\n", line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                if(open.type!=STAPLE_LARGE) {
                    printf("JbȒΉƂĂ܂\n");
                    printf("%ds%dɑΉJbR"
                            "%ds%dɑΉJbR̎ނ"
                            "Ⴂ܂\n", open.line, open.column,
                                            line, carryover + i + 1);
                    return EXIT_FAILURE;
                }
                break;
            }
        }

        if(buffer[len - 1] == '\n') {
            carryover = 0;
            line++;
        } else {
            /* 4096ǂݍłCsɏoȂꍇ */
            carryover += len;
        }
    }

    /* SɃJbȒΉƂĂ
       X^bN͋ɂȂĂ͂ */
    if(staple_head != NULL) {
        /* JJbR */
        printf("JbȒΉƂĂ܂\n");
        printf("JJbR̐܂\n");
        return EXIT_FAILURE;
    }

    printf("JbȒΉ͐ƂĂ܂\n");
    return EXIT_SUCCESS;
}
