#include <stdio.h>
#include <stdlib.h>

typedef struct _tag_tree_node {
    /* nodel */
    int value;
    /* 菬lnodeF}ł͍node */
    struct _tag_tree_node *left;
    /* 傫lnodeF}ł͉Enode */
    struct _tag_tree_node *right;
} tree_node;

tree_node *tree_root = NULL;

tree_node* create_new_node(int num) {
    tree_node *tree_new;

    /* Vnode쐬āC */
    tree_new = (tree_node*)malloc(sizeof(tree_node));
    if(tree_new == NULL) {
        exit(EXIT_FAILURE);
    }
    tree_new->left = NULL;
    tree_new->right = NULL;
    tree_new->value = num;

    return tree_new;
}

void insert_tree(int num, tree_node *node) {
    /* 1}ĂȂꍇ */
    if(node == NULL) {
        tree_root = create_new_node(num);
        return;
    }

    /* num݂node̒lꍇ */
    if(node->value > num) {
        if(node->left != NULL) {
            insert_tree(num, node->left);
        } else {
            /* ɒǉ */
            node->left = create_new_node(num);
        }
    } else {
    /* num݂node̒lȏ̏ꍇ */
        if(node->right!=NULL) {
            insert_tree(num, node->right);
    	} else {
            /* Eɒǉ */
            node->right = create_new_node(num);
        }
    }

    return;
}

tree_node* find_value(tree_node* node,int val) {
/* tree_nodẽ|C^ԂBȂꍇNULL */

    /* 菬lȂ΁C */
    if(node->value>val) {
        if(node->left == NULL) {  /* ɂȂ΁Cval͂Ȃ */
            return NULL;
        }
        return find_value(node->left,val);
    }
    /* 傫lȂ΁CE */
    if(node->value < val) {
        if(node->right == NULL) {
            return NULL;      /* EɂȂ΁Cval͂Ȃ */
        }
        return find_value(node->right, val);
    }

    /* ΁ClԂ */
    return node;
}

int delete_tree(int val) {
/* val폜B1Cs0Ԃ */
    tree_node *node, *parent_node;
    tree_node *left_biggest;
    int direction;
    node = tree_root;
    parent_node = NULL;
    direction = 0;

    /* whileō폜ׂΏۂ(find_valueƓ) */
    while(node != NULL && node->value != val) {
        if(node->value > val) {
            parent_node = node;
            node = node->left;
            direction = -1;       /* e̍ */
        } else {
            parent_node = node;
            node = node->right;
            direction = 1;        /* ẻE */
        }
    }
    if(node == NULL) {  /* Ȃ */
        return 0;
    }

    if(node->left == NULL || node->right == NULL) {
        /* ECǂ炩NULLłꍇ
           (NULL̏ꍇ܂) */
        if(node->left == NULL) {
            /* ẽ|C^ύX */
            if(direction == -1) {
                parent_node->left = node->right;
            }
            if(direction == 1) {
                parent_node->right = node->right;
            }
            if(direction==0) {
                tree_root = node->right;
            }
        } else {
            /* ẽ|C^ύX */
            if(direction == -1) {
                parent_node->left = node->left;
            }
            if(direction == 1) {
                parent_node->right = node->left;
            }
            if(direction == 0) {
                tree_root = node->left;
            }
        }

        free(node);
    } else {
        /* ҂ƂNULLłȂꍇ */

        /* node̍̍ł傫ȒliłE̒lj擾 */
        left_biggest = node->left;
        parent_node = node;
        direction = -1;
        while(left_biggest->right != NULL) {
            parent_node = left_biggest;
            left_biggest = left_biggest->right;
            direction = 1;
        }

        /* left_biggest̒lnodeɑC
           left_biggest͍̎} */
        node->value = left_biggest->value;
        if(direction == -1) {
            parent_node->left = left_biggest->left;
        } else {
            parent_node->right = left_biggest->left;
        }
        free(left_biggest);
    }

    return 1;
}

void print_tree(int depth,tree_node* node) {
    int i;

    if(node == NULL) {
        return;
    }
    print_tree(depth + 1, node->left);
    for(i = 0; i < depth; i++) {
        printf("  ");
    }
    printf("%d\n", node->value);
    print_tree(depth + 1, node->right);
}

void free_tree(tree_node* node) {
    if(node == NULL) {
        return;
    }
    /* ܂qnodẽ */
    free_tree(node->left);
    free_tree(node->right);
    /* g */
    free(node);
}

int main(void) {
    int i, action;

    for(i = 0; i < 10; i++) {
        insert_tree(rand() % 99 + 1, tree_root);
    }
    for(;;) {
        print_tree(0, tree_root);
        printf("s鑀̃^Cv͂ĂB\n \
            1 Fǉ\t2 F\t3 F폜\t ȊOFI>");
        scanf("%d", &action);
        switch(action) {
        case 1:
            printf("1 `100͈̔͂ŁCǉ鐔"
                                            "͂Ă:");
            scanf("%d", &i);
            if(i < 1 || i > 100) {
                continue;
            }
            insert_tree(i, tree_root);
            break;
        case 2:
            printf("鐔͂Ă:");
            scanf("%d", &i);
            if(find_value(tree_root, i) != NULL) {
                printf("%d𔭌܂\n", i);
            } else {
                printf("%d͌܂ł\n", i);
            }
            break;
        case 3:
            printf("폜鐔͂Ă:");
            scanf("%d", &i);
            if(delete_tree(i) == 1) {
                printf("%d폜܂\n", i);
            } else {
                printf("%d͌܂ł\n", i);
            }
            break;
        default:
            free_tree(tree_root);
            return EXIT_SUCCESS;
        }
    }
}
