/* nbV}bṽvO */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* pP&aێ\ */
typedef struct {
    char *english;
    char *japanese;
} WORDSET;

/* nbV\ */
typedef struct {
    WORDSET **data;
    unsigned int size;
} HASHTABLE;

/* ASCIIR[hɏd|ănbVl𐶐 */
unsigned int MakeHash2(char* str, unsigned int hashmax) {
    unsigned int n, length, hash, weight;

    length = strlen(str);
    for(n = weight = hash = 0; n < length; n++, weight++) {
        /* d256^7܂œBCꏄčĂьɖ߂ */
        if(weight > 7) {
            weight = 0;
        }
        hash += (int)str[n] << (4 * weight);
        /* u<<(4*weight)v́u256^weightvƓӖ */
    }

    return hash % hashmax;
}

/* firsthasḧʒu܂ĂꍇɍănbVs߂̊֐ */
unsigned int ReHash(HASHTABLE *hashtable, unsigned int firsthash) {
    unsigned int hashval, k;

    /* firstvalk^2ɂ󂫈ʒuTB
       uk>nbV\TCY̔vƂȂC
        ȍ~̒T̓_ */
    for(k = 1; k <= hashtable->size / 2; k++) {
        hashval = (firsthash + k * k) % hashtable->size;
        if(hashtable->data[hashval] == NULL) {
            return hashval;
        }
    }

    /* 󂫈ʒuȂ-1Ԃ */
    return -1;
}

/* newdatahashtableɒǉ */
void AddDataToMap(HASHTABLE *hashtable, WORDSET *newdata) {
    unsigned int hashval;

    /* pPɃnbVl𐶐 */
    hashval = MakeHash2(newdata->english, hashtable->size);

    /* hasḧʒułɖ܂ĂCănbVs */
    if(hashtable->data[hashval] != NULL) {
        hashval = ReHash(hashtable, hashval);

        /* ănbVʂ-1ł΁C󂫈ʒuȂ
           (}bvt) */
        if(hashval==-1) {
            printf("%s}bvɑ}悤Ǝ݂܂C"
                        "󂫈ʒu܂łB\n"
                                            , newdata->english);
            return;
        }
    }

    /* hashval̈ʒunewdataւ̃|C^i[ */
    hashtable->data[hashval] = newdata;
}

/* pPkeyɑΉahashtableToĕԂ */
char *GetDataFromMap(HASHTABLE *hashtable, char *key) {
    unsigned int hashval, k;
    WORDSET *word;

    /* TJnnbVl߂ */
    hashval = MakeHash2(key, hashtable->size);

    /* ̈ʒu珇ԂɁC
       keyƓlf[^܂ŒTs */
    for(k = 0; k <= hashtable->size / 2; k++) {
        word = hashtable->data[(hashval + k * k) % hashtable->size];
        if(word != NULL) {
            if(strcmp(key, word->english) == 0) {
                return word->japanese;
            }
        }
    }

    /* nbV\TCY̔ɑ񐔒TĂ
       Ȃꍇ́CYf[^nbV\̂Ȃ
       ȂƂӖ */
    return NULL;
}

/* pPkeyɊւf[^hashtable菜
   (f[^͍̂̂폜Ȃ) */
WORDSET *DeleteDataFromMap(HASHTABLE *hashtable, char *key) {
    unsigned int hashval, k;
    WORDSET *word;

    /* TJnnbVl߂ */
    hashval = MakeHash2(key, hashtable->size);

    /* ̈ʒu珇ԂɁCkeyƓlf[^܂
       Ts */
    for(k = 0; k <= hashtable->size / 2; k++) {
        word = hashtable->data[(hashval + k * k) % hashtable->size];
        if(word != NULL) {
            if(strcmp(key, word->english) == 0) {
                hashtable->data
                            [(hashval + k * k) % hashtable->size] = NULL;
                /* nbVe[u菜f[^Ԃ */
                return word;
            }
        }
    }

    /* nbV\TCY̔ɑ񐔒TĂ
       Ȃꍇ́CYf[^nbV\̂Ȃ
       ȂƂӖ */
    return NULL;
}

/* nbVe[uw肵TCYɏ */
void InitHashTable(HASHTABLE *hashtable, unsigned int size) {
    hashtable->data = (WORDSET**)malloc(sizeof(WORDSET*) * size);
    /* nbVe[uNULLŖ߂ */
    memset(hashtable->data, NULL, sizeof(WORDSET*) * size);
    hashtable->size = size;
}

/* nbVe[ũN[Abv */
void CleanupHashTable(HASHTABLE *hashtable) {
    free(hashtable->data);
    hashtable->size = 0;
}


/* hashtablȇSf[^\iPȂ\pj */
void PrintAllData(HASHTABLE *hashtable) {
    unsigned int n;
    for(n = 0; n < hashtable->size; n++) {
        if(hashtable->data[n] != NULL) {
            printf("%d:\t%s\t%s\n", n, hashtable->data[n]->english
                                , hashtable->data[n]->japanese);
        }
    }
}

int main(void) {
    unsigned int n;
    char key[64], *japanese;
    HASHTABLE hashtable;
    WORDSET *wordfound;
    WORDSET words[5] = {
            {"dolphin", "CJ"},{"beluga", "VCJ"},
            {"grampus", "V`"},{"medusa", "C"},
            {"otter", "JE\"}
    };

    /* nbVe[ȕ */
    InitHashTable(&hashtable, 503);

    /* f[^ǉ */
    for(n = 0; n < 5; n++) {
        AddDataToMap(&hashtable, &words[n]);
    }

    do {
        printf("ǂ̑s܂?i1: 2:폜 "
                                    "3:S\ 0:Ij\n>");
        scanf("%d", &n);
        switch(n) {
        case 1: /*  */
            printf("pP͂ĂF");
            scanf("%s", key);
            japanese = GetDataFromMap(&hashtable, key);
            if(japanese != NULL) {
                printf("%s̘a%słB\n", key, japanese);
            } else {
                printf("%s}bv̂Ȃ"
                            "܂łB\n", key);
            }
            break;
        case 2: /* 폜 */
            printf("폜pP͂ĂF");
            scanf("%s", key);
            wordfound = DeleteDataFromMap(&hashtable, key);
            if(wordfound != NULL) {
                printf("%s}bv폜܂B\n", key);
            } else {
                printf("%s}bv̂Ȃ"
                            "܂łB\n", key);
            }
            break;
        case 3: /* S\ */
            PrintAllData(&hashtable);
            break;
        }
    } while(n != 0);

    CleanupHashTable(&hashtable);   /* N[Abv */

    return 0;
}
