import java.util.Arrays;
import java.io.BufferedReader;

class ComparableBook implements Comparable {
    public final String title;
    public final String author;
    public final int bookID;
    public final boolean available;

    ComparableBook(String title, String author,
                    int bookID, boolean available) {
        this.title = title;
        this.author = author;
        this.bookID = bookID;
        this.available = available;
    }

    ComparableBook(int bookID) {
        title = author = null;
        this.bookID = bookID;
        available = false;
    }

    public int compareTo(Object o) {
        return bookID - ((ComparableBook) o).bookID;
    }
}

class List2_6 {
    private static ComparableBook[] bookArray;

    private static void initData() {
        bookArray = new ComparableBook[5];

        bookArray[0] = new ComparableBook
                                ("book0", "author0", 1000, true);
        bookArray[1] = new ComparableBook
                                ("book1", "author1", 502, false);
        bookArray[2] = new ComparableBook
                                ("book2", "author2", 731, false);
        bookArray[3] = new ComparableBook
                                ("book3", "author3", 628, true);
        bookArray[4] = new ComparableBook
                                ("book4", "author4", 1, true);
    }

    public static void main(String args[]) {

        initData();
        Arrays.sort(bookArray);

        while (true) {
            System.out.print("{̔ԍ͂Ă" +
                                "iIꍇ0́j:");
            int key = intReader();
            if (key == 0) {
                // 0͂ꂽI
                break;
            }

            // Čʂ\
            int position = Arrays.binarySearch(bookArray,
                                        new ComparableBook(key));
            if (position >= 0) {
                System.out.println("--̖{܂--");
                System.out.println("[^Cg]" +
                                bookArray[position].title);
                System.out.println("[]" +
                                bookArray[position].author);
                System.out.println("[Ǘԍ]" +
                                bookArray[position].bookID);
                if (bookArray[position].available) {
                    System.out.println
                                ("̖{݂͑o\łB");
                } else {
                    System.out.println("\󂠂܂񂪁C" + 
                                    "̖{݂͑ołB");
                }
            } else {
                System.out.println
                            ("T̖{͌܂łB");
            }
        }
    }

    private static int intReader() {
        try {
            BufferedReader read = new BufferedReader
                        (new java.io.InputStreamReader(System.in));
            String str = read.readLine();
            return Integer.parseInt(str);
        } catch (java.io.IOException e) {
            System.err.println("IO exception");
            return 0;
        } catch (NumberFormatException e) {
            return 0;
        }
    }
}

