import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;

class Staple {
    Staple(int line, int column, int type) {
        this.line = line;
        this.column = column;
        this.type = type;
    }

    Staple(Staple clone) {
        this.line = clone.line;
        this.column = clone.column;
        this.type = clone.type;
    }

    public final int line;
    public final int column;
    public final int type;
    public Staple next = null;
    public Staple prev = null;

    static public int SMALL = 0;
    static public int MEDIUM = 1;
    static public int LARGE = 2;
}

class IllegalStapleException extends Exception {
}

class StackByList {
    StackByList() {
        head = last = null;
    }

    private Staple head;
    private Staple last;

    public void push(int line, int column, int type) {
        Staple newStaple = new Staple(line, column, type);
        // Xg̍Ōɒǉ
        newStaple.next = null;
        newStaple.prev = last;
        last = newStaple;
        if (head == null) {
            head = newStaple;
        }
    }

    public Staple pop() throws IllegalStapleException {
        if (isEmpty()) {
            // X^bNɂ͉Ȃ:JbȒΉƂĂȂ
            throw new IllegalStapleException();
        }
        Staple ret = new Staple(last);
        // Xg폜
        if (last.prev == null) {
            head = null;
        } else {
            last.prev.next = null;
        }
        last = last.prev;
        return ret;
    }

    public boolean isEmpty() {
        return (head == null);
    }
}

class List4_2 {
    public static void main(String args[]) {
        BufferedReader reader = new BufferedReader
                        (new InputStreamReader(System.in));
        StackByList stack = new StackByList();

        int line = 0;
        while (true) {
            try {
                String str = reader.readLine();
                if (str == null) {
                    break;
                }
                line++;

                for (int i = 0; i < str.length(); i++) {
                    switch (str.charAt(i)) {
                        case '(':
                            stack.push(line, i + 1, Staple.SMALL);
                            break;
                        case '{':
                            stack.push(line, i + 1, Staple.MEDIUM);
                            break;
                        case '[':
                            stack.push(line, i + 1, Staple.LARGE);
                            break;
                        case ')':
                            try {
                                Staple open = stack.pop();
                                if (open.type != Staple.SMALL) {
                                    System.out.println
                                    ("JbȒΉƂĂ܂");
                                    System.out.println
                (open.line + "s" + open.column + "ɑΉ"+
                 "JbR" + line + "s" + (i+1) + "ɑΉ"+
                 "JJbR܂");
                                    return;
                                }
                            } catch (IllegalStapleException e) {
                                System.out.println
                                ("JbȒΉƂĂ܂");
                                System.out.println(line + "s" +
                                    (i + 1) + "ɑΉ" +
                                    "JbR̎ނႢ܂");
                                return;
                            }
                            break;
                        case '}':
                            try {
                                Staple open = stack.pop();
                                if (open.type != Staple.MEDIUM) {
                                    System.out.println
                                    ("JbȒΉƂĂ܂");
                                    System.out.println
                (open.line + "s" + open.column + "ɑΉ"+
                 "JbR" + line + "s" + (i+1) + "ɑΉ"+
                 "JJbR܂");
                                    return;
                                }
                            } catch (IllegalStapleException e) {
                                System.out.println
                                ("JbȒΉƂĂ܂");
                                System.out.println
                                (line + "s" + (i + 1) + ""+
                                "ΉJbR̎ނႢ܂");
                                return;
                            }
                            break;
                        case ']':
                            try {
                                Staple open = stack.pop();
                                if (open.type != Staple.LARGE) {
                                    System.out.println
                                    ("JbȒΉƂĂ܂");
                                    System.out.println
                (open.line + "s" + open.column + "ɑΉ"+
                 "JbR" + line + "s" + (i+1) + "ɑΉ"+
                 "JJbR܂");
                                    return;
                                }
                            } catch (IllegalStapleException e) {
                                System.out.println
                                ("JbȒΉƂĂ܂");
                                System.out.println
                                (line + "s" + (i + 1) + ""+
                                "ΉJbR̎ނႢ܂");
                                return;
                            }
                            break;
                    }
                }
            } catch (IOException e) {
                System.err.println("IO exception");
                break;
            }
        }

        // SɃJbȒΉƂĂ΁C
        // X^bN͋ɂȂĂ͂
        if (!stack.isEmpty()) {
            System.out.println("JbȒΉƂĂ܂");
            System.out.println("JJbR̐܂");
            return;
        }
        System.out.println("JbȒΉ͐ƂĂ܂");
    }
}
