import java.io.BufferedReader;

class List7_3 {
    static class Wordset {
        Wordset(String english, String japanese) {
            this.english = english;
            this.japanese = japanese;
        }

        public String english;
        public String japanese;
    }

    static class MyHashTable {
        public Wordset[] data;
        public int size;
    }

    private static int makeHash2(String str, int hashMax) {
        int hash = 0, weight = 0;

        for (int n = 0; n < str.length(); ++n, ++weight) {
            if (weight > 7) {
                // d256^7܂œBCꏄčĂьɖ߂
                weight = 0;
            }
            // u<< (4 * weight)v́u256^weightvƓӖ
            hash += (int) str.charAt(n) << (4 * weight);
        }

        return hash % hashMax;
    }

    private static int reHash(MyHashTable hashTable,
                                    int firstHash) {
        int hashValue = firstHash;
        // firstvalk^2ɂ󂫈ʒuTB
        // uk > nbV\TCY̔vƂȂC
        // ȍ~̒T̓_
        for (int k = 1; k < hashTable.size / 2; k++) {
            hashValue = (firstHash + k * k) % k;
            if (hashTable.data[hashValue] != null) {
                return hashValue;
            }
        }
        // 󂫈ʒuȂ-1Ԃ
        return -1;
    }

    private static void addDataToMap(MyHashTable hashTable,
                                            Wordset newData) {
        // pPɃnbVl𐶐
        int hashValue = makeHash2(newData.english, hashTable.size);

        // hasḧʒułɖ܂ĂCănbVs
        if (hashTable.data[hashValue] != null) {
            hashValue = reHash(hashTable, hashValue);
            // ănbVʂ-1ł΁C
            // 󂫈ʒuȂi}bvtj
            if (hashValue == -1) {
                System.out.println(newData.english +
                            "}bvɑ}悤Ǝ݂܂C"+
                            "󂫈ʒu܂łB");
                return;
            }
        }
        // hashval̈ʒunewdataւ̃|C^i[
        hashTable.data[hashValue] = newData;
    }

    private static String getDataFromMap(MyHashTable hashTable,
                                                String key) {
        // TJnnbVl߂
        int hashValue = makeHash2(key, hashTable.size);
        Wordset word;

        // ̈ʒu珇ԂɁC
        // keyƓlf[^܂ŒTs
        for (int k = 0; k <= hashTable.size / 2; k++) {
            word = hashTable.data[
                    (hashValue + k * k) % hashTable.size];
            if (word != null) {
                if (key.equals(word.english)) {
                    return word.japanese;
                }
            }
        }

        // nbV\TCY̔ɑ
        // TĂȂꍇ́C
        // Yf[^nbV\̂ȂɂȂƂӖ
        return null;
    }

    private static Wordset deleteDataFromMap
                        (MyHashTable hashTable, String key) {
        // TJnnbVl߂
        int hashValue = makeHash2(key, hashTable.size);
        Wordset word;

        // ̈ʒu珇ԂɁCkeyƓlf[^
        // ܂ŒTs
        for (int k = 0; k <= hashTable.size / 2; k++) {
            word = hashTable.data[
                        (hashValue + k * k) % hashTable.size];
            if (word != null) {
                if (key.equals(word.english)) {
                    hashTable.data[(hashValue + k * k) %
                                        hashTable.size] = null;
                    // nbVe[u菜f[^Ԃ
                    return word;
                }
            }
        }

        // nbV\TCY̔ɑ
        // TĂȂꍇ́C
        // Yf[^nbV\̂ȂɂȂƂӖ
        return null;
    }

    private static void initHashTable(MyHashTable hashTable,
                                                    int size) {
        hashTable.data = new Wordset[size];
        for (int i = 0; i < size; i++) {
            hashTable.data[i] = null;
        }
        hashTable.size = size;
    }

    private static void printAllData(MyHashTable hashTable) {
        for (int n = 0; n < hashTable.size; n++) {
            if (hashTable.data[n] != null) {
                System.out.println(n + ":\t" +
                            hashTable.data[n].english + "\t" +
                            hashTable.data[n].japanese);
            }
        }
    }

    public static void main(String[] args) {
        Wordset words[] = {
                new Wordset("dolphin", "CJ"),
                new Wordset("beluga", "VCJ"),
                new Wordset("grampus", "V`"),
                new Wordset("medusa", "C"),
                new Wordset("otter", "JE\") };
        MyHashTable hashTable = new MyHashTable();
        // nbVe[ȕ
        initHashTable(hashTable, 503);
        for (int n = 0; n < words.length; n++) {
            // f[^ǉ
            addDataToMap(hashTable, words[n]);
        }

        int action;
        do {
            System.out.print("ǂ̑s܂?" +
                        "i1: 2:폜 3:S\ 0:Ij\n>");
            action = intReader();
            switch (action) {
                case 1:
                    {
                        System.out.print(
                            "pP͂ĂF");
                        String key = stringReader();
                        String japanese =
                                    getDataFromMap(hashTable, key);
                        if (japanese != null) {
                            System.out.println(key + "̘a" +
                                            japanese + "łB");
                        } else {
                            System.out.println(key + "}bv" +
                                    "ȂɌ܂łB");
                        }
                        break;
                    }
                case 2:
                    {
                        System.out.print(
                            "폜pP͂ĂF");
                        String key = stringReader();
                        Wordset wordFound =
                                deleteDataFromMap(hashTable, key);
                        if (wordFound != null) {
                            System.out.println(key + 
                                    "}bv폜܂B");
                        } else {
                            System.out.println(key + "}bv" +
                                    "ȂɌ܂łB");
                        }
                        break;
                    }
                case 3:
                    {
                        printAllData(hashTable);
                        break;
                    }
            }
        } while (action != 0);
    }

    private static String stringReader() {
        try {
            BufferedReader read = new BufferedReader
                        (new java.io.InputStreamReader(System.in));
            return read.readLine();
        } catch (java.io.IOException e) {
            System.err.println("IO exception");
            return "";
        }
    }

    private static int intReader() {
        try {
            BufferedReader read = new BufferedReader
                        (new java.io.InputStreamReader(System.in));
            String str = read.readLine();
            return Integer.parseInt(str);
        } catch (java.io.IOException e) {
            System.err.println("IO exception");
            return 0;
        } catch (NumberFormatException e) {
            return 0;
        }
    }
}